program SDFFS
    use funcs_SDFFS
    use mpi
    implicit none

    integer, dimension (mpi_status_size) :: statusMPI
    integer :: mynode, tn, error_number

    integer, parameter :: K1 = 35
    integer, parameter :: K2 = 35
    integer, parameter :: NN = 8345 !This is the number of rows (points) in Data file
    integer :: i,j,m,n, aux
    real :: l,h, t1, t2 !Wonder if I can define this variables as parameters
    double precision :: pi !Wonder if I can define this variables as parameters
    double precision, dimension(:,:), allocatable :: D
    double precision, dimension(:,:), allocatable :: He1, He2
    double precision, dimension(:,:), allocatable :: Hesub1, Hesub2, Heaux	
    double precision, dimension(:), allocatable :: b_vec
    
    pi = 4*ATAN(1.0)
    l=1.2 !I need to adjust this value
    h=1.2 !I need to adjust this value
    !lambda=0.00000000001 !I need to adjust this value
    aux = (K1+1)*(K2+1)
        
    call mpi_init(error_number)
    call mpi_comm_size(mpi_comm_world, tn, error_number)
    call mpi_comm_rank(mpi_comm_world, mynode, error_number)

    t1 = mpi_wtime()

    allocate(Hesub1(aux,aux))
    allocate(Hesub2(aux,aux))
    allocate(D(NN,3))	

    !Read data form DataFranke.txt file. This has to be in the same directory as the source file
    open(unit=1,file="glacier.txt",status='old')
    do i=1,NN
        read(1,*) D(i,:)
    end do
    close(unit=1)

    if (mynode == 0) then	
		allocate(b_vec(4*aux))
		allocate(Heaux(aux,aux))
		allocate(He1(4*aux,4*aux))
		allocate(He2(4*aux,4*aux))
		He1 = 0.0
		He2 = 0.0
    	do i=0,K1
	      do j=0,K2
		    b_vec(phi(i,j,K2))=(2.0/NN)*SUM(D(:,3)*COS(pi*dble(i)*D(:,1)/l)*COS(pi*dble(j)*D(:,2)/h))
		    b_vec(phi(i,j,K2)+aux)=(2.0/NN)*SUM(D(:,3)*SIN(pi*dble(i)*D(:,1)/l)*COS(pi*dble(j)*D(:,2)/h))
		    b_vec(phi(i,j,K2)+2*aux)=(2.0/NN)*SUM(D(:,3)*COS(pi*dble(i)*D(:,1)/l)*SIN(pi*dble(j)*D(:,2)/h))		
		    b_vec(phi(i,j,K2)+3*aux)=(2.0/NN)*SUM(D(:,3)*SIN(pi*dble(i)*D(:,1)/l)*SIN(pi*dble(j)*D(:,2)/h))
	      end do
    	end do

    	open(unit=0,file="b_vec.txt",ACTION="write")
    	do j=1,4*(K1+1)*(K2+1)
	      write(0,'(1000F14.7)' ) dble(b_vec(j))
    	end do
    	close(unit=0)
		deallocate(b_vec)
		print *,'rhs vector saved'
    end if
	
    if (mynode == 0) then
	    do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
                        !Delta^2L_{1,1} This matrix block contains partial^2L/(partial a_{i,j} partial a_{m,n})
                        He1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(COS(pi*m*D(:,1)*(l**(-1)))*COS(pi*n*D(:,2)*(h**(-1)))*&
                                               COS(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1))))
			            He2(phi(i,j,K2),phi(m,n,K2))=4*(pi**4)/((l**2)*(h**2))*m*n*i*j*int_sin4(m,n,i,j,l,h)+&
                                              2*((pi/l)**4*m**2*i**2 + (pi/h)**4*(n**2)*(j**2) )*int_cos4(m,n,i,j,l,h) 
                        !end Delta^2L_{1,1} This matrix block contains partial^2L/(partial a_{i,j} partial a_{m,n})
		            end do
		        end do
	        end do
	    end do
    end if
    if (mynode == 1) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2                        
                        !Delta^2L_{1,2} This matrix block contains partial^2L/(partial a_{i,j} partial b_{m,n})
                        Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*COS(pi*n*D(:,2)*(h**(-1)))*&
                                                     COS(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1))))
                        !end Delta^2L_{1,2} This matrix block contains partial^2L/(partial a_{i,j} partial b_{m,n})
                    end do
		        end do
	        end do
	    end do
        !Send to processor 0 with label 1			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,1,mpi_comm_world,error_number)
    end if
    if (mynode == 0) then
        !Receive from processor 1 with label 1
	     call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,1,1,mpi_comm_world,statusMPI,error_number)
	     He1(1:aux,aux+1:2*aux)=Heaux
    end if
    if (mynode == 2) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
                        !Delta^2L_{1,3} This matrix block contains partial^2L/(partial a_{i,j} partial c_{m,n})
                        Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(COS(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                                     COS(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1))))
                        !end Delta^2L_{1,3} This matrix block contains partial^2L/(partial a_{i,j} partial c_{m,n})
                    end do
	            end do
	        end do
	    end do
	    !Send to processor 0 with label 2			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,2,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
        !Receive from processor 2 with label 2
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,2,2,mpi_comm_world,statusMPI,error_number)
	    He1(1:aux,2*aux+1:3*aux)=Heaux
    end if
    if (mynode == 3) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
                        !Delta^2L_{1,4} This matrix block contains partial^2L/(partial a_{i,j} partial d_{m,n})
                        Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                                     COS(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1))))
                        !end Delta^2L_{1,4} This matrix block contains partial^2L/(partial a_{i,j} partial d_{m,n})
                    end do
	            end do
	        end do
	    end do
        !Send to processor 0 with label 3			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,3,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
	    !Receive from processor 3 with label 3
        call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,3,3,mpi_comm_world,statusMPI,error_number)
   	    He1(1:aux,3*aux+1:4*aux)=Heaux
    end if
    if (mynode == 4) then
	    do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
                        !Delta^2L_{2,2} This matrix block contains partial^2L/(partial b_{i,j} partial b_{m,n})
                        Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*COS(pi*n*D(:,2)*(h**(-1)))*&
                                         SIN(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1))))
			            Hesub2(phi(i,j,K2),phi(m,n,K2))=4*(pi**4)/((l**2)*(h**2))*m*n*i*j*int_cossincossin(m,n,i,j,l,h)+&
                                         2*((pi/l)**4*m**2*i**2 + (pi/h)**4*(n**2)*(j**2) )*int_sincossincos(m,n,i,j,l,h) 
                        !end Delta^2L_{2,2} This matrix block contains partial^2L/(partial b_{i,j} partial b_{m,n})
		           end do
	           end do
	       end do
	   end do	
	   !Send to processor 0 with label 4			
	   call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,4,mpi_comm_world,error_number)
       !Send to processor 0 with label 5			
	   call mpi_send(Hesub2(1,1),aux*aux,mpi_double_precision,0,5,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
	    !Receive from processor 4 with label 4
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,4,4,mpi_comm_world,statusMPI,error_number)
	    He1(aux+1:2*aux,aux+1:2*aux)=Heaux
        !Receive from processor 4 with label 5
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,4,5,mpi_comm_world,statusMPI,error_number)
	    He2(aux+1:2*aux,aux+1:2*aux)=Heaux        
    end if
    if (mynode == 5) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
		                !Delta^2L_{2,3} This matrix block contains partial^2L/(partial b_{i,j} partial c_{m,n})
		                Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(COS(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                                     SIN(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1)))) 
		                !end Delta^2L_{2,3} This matrix block contains partial^2L/(partial b_{i,j} partial c_{m,n}
                    end do
	            end do
	        end do
	    end do
        !Send to processor 0 with label 6			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,6,mpi_comm_world,error_number)  
    end if
    if (mynode==0) then
        !Receive from processor 5 with label 6
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,5,6,mpi_comm_world,statusMPI,error_number)
	    He1(aux+1:2*aux,2*aux+1:3*aux)=Heaux
    end if
    if (mynode == 6) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
		                !Delta^2L_{2,4} This matrix block contains partial^2L/(partial b_{i,j} partial d_{m,n})
		                Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                                     SIN(pi*i*D(:,1)*(l**(-1)))*COS(pi*j*D(:,2)*(h**(-1)))) 
		                !end Delta^2L_{2,4} This matrix block contains partial^2L/(partial b_{i,j} partial d_{m,n})
                    end do
	            end do
	        end do
	    end do
	    !Send to processor 0 with label 7			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,7,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
        !Receive from processor 6 with label 7
        call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,6,7,mpi_comm_world,statusMPI,error_number)
	    He1(aux+1:2*aux,3*aux+1:4*aux)=Heaux
    end if
    if (mynode == 7) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2  	
                        !Delta^2L_{3,3} This matrix block contains partial^2L/(partial c_{i,j} partial c_{m,n})
                        Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(COS(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                         COS(pi*i*D(:,1)*(l**(-1)))*SIN(pi*j*D(:,2)*(h**(-1))))
			            Hesub2(phi(i,j,K2),phi(m,n,K2))=4*(pi**4)/((l**2)*(h**2))*m*n*i*j*int_sincossincos(m,n,i,j,l,h)+&
                                         2*((pi/l)**4*m**2*i**2 + (pi/h)**4*(n**2)*(j**2) )*int_cossincossin(m,n,i,j,l,h) 
		                !end Delta^2L_{3,3} This matrix block contains partial^2L/(partial c_{i,j} partial c_{m,n})
                    end do
	            end do
	        end do
	    end do
	    !Send to processor 0 with label 8			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,8,mpi_comm_world,error_number)
        !Send to processor 0 with label 9			
	    call mpi_send(Hesub2(1,1),aux*aux,mpi_double_precision,0,9,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
        !Receive from processor 7 with label 8
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,7,8,mpi_comm_world,statusMPI,error_number)
	    He1(2*aux+1:3*aux,2*aux+1:3*aux)=Heaux
        !Receive from processor 7 with label 9
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,7,9,mpi_comm_world,statusMPI,error_number)
	    He2(2*aux+1:3*aux,2*aux+1:3*aux)=Heaux
    end if
    if (mynode == 8) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
                        !Delta^2L_{3,4} This matrix block contains partial^2L/(partial c_{i,j} partial d_{m,n})
		                Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                                     COS(pi*i*D(:,1)*(l**(-1)))*SIN(pi*j*D(:,2)*(h**(-1)))) 
		                !end Delta^2L_{3,4} This matrix block contains partial^2L/(partial c_{i,j} partial d_{m,n})
                    end do
	            end do
	        end do
	    end do
	    !Send to processor 0 with label 10			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,10,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
        !Receive from processor 8 with label 10
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,8,10,mpi_comm_world,statusMPI,error_number)
	    He1(2*aux+1:3*aux,3*aux+1:4*aux)=Heaux
    end if
    if (mynode == 9) then
        do i = 0,K1
            do j = 0,K2
                do m = 0, K1 
                    do n = 0,K2
		                !Delta^2L_{4,4} This matrix block contains partial^2L/(partial d_{i,j} partial d_{m,n})
		                Hesub1(phi(i,j,K2),phi(m,n,K2))=(2.0/NN)*SUM(SIN(pi*m*D(:,1)*(l**(-1)))*SIN(pi*n*D(:,2)*(h**(-1)))*&
                                               SIN(pi*i*D(:,1)*(l**(-1)))*SIN(pi*j*D(:,2)*(h**(-1)))) 
			            Hesub2(phi(i,j,K2),phi(m,n,K2))=4*(pi**4)/((l**2)*(h**2))*m*n*i*j*int_cos4(m,n,i,j,l,h)+&
                                              2*((pi/l)**4*m**2*i**2 + (pi/h)**4*(n**2)*(j**2) )*int_sin4(m,n,i,j,l,h)
		                !end Delta^2L_{4,4} This matrix block contains partial^2L/(partial d_{i,j} partial d_{m,n})
                    end do
                end do
            end do
    	end do
	    !Send to processor 0 with label 11			
	    call mpi_send(Hesub1(1,1),aux*aux,mpi_double_precision,0,11,mpi_comm_world,error_number)
        !Send to processor 0 with label 12			
	    call mpi_send(Hesub2(1,1),aux*aux,mpi_double_precision,0,12,mpi_comm_world,error_number)
    end if
    if (mynode==0) then
        !Receive from processor 9 with label 11
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,9,11,mpi_comm_world,statusMPI,error_number)
	    He1(3*aux+1:4*aux,3*aux+1:4*aux)=Heaux
        !Receive from processor 9 with label 12
	    call mpi_recv(Heaux(1,1),aux*aux,mpi_double_precision,9,12,mpi_comm_world,statusMPI,error_number)
	    He2(3*aux+1:4*aux,3*aux+1:4*aux)=Heaux
    end if

    if (mynode==0) then
        open(unit=1,file="He1.txt",ACTION="write")
        do i=1,4*(K1+1)*(K2+1)
	        write(1, *) ( dble(He1(i,j)),j=1,4*(K1+1)*(K2+1))	 	
        end do
        close(unit=1)
        open(unit=2,file="He2.txt",ACTION="write")
        do i=1,4*(K1+1)*(K2+1)
	        write(2, *) ( dble(He2(i,j)),j=1,4*(K1+1)*(K2+1))	 	
        end do
        close(unit=2)

	    deallocate(He1)
        deallocate(He2)
	    deallocate(Heaux) 
	    print *,'The Hessian was calculated'
	    
	    t2 = mpi_wtime()

	    open(unit=3,file="elapsedTime.txt",ACTION="write")
	    write(3, *) (t2-t1)	 	
        close(unit=3)

	    print *, 'total time ', t2-t1
    end if

    deallocate(Hesub1)
    deallocate(Hesub2)
    deallocate(D)
    
    call mpi_finalize(error_number)

contains
!The following function computes the row or column index of part of the matrix given i,j or m,n
!It is just one of the 16 blocks of the matrix
integer function phi(i,j,K2) result(s)
    integer, intent(in) :: i
    integer, intent(in) :: j
    integer, intent(in) :: K2
    s = i*(K2+1) + (j+1)
end function phi

end program SDFFS
