module funcs_SDFFS

    !double precision, parameter :: pi=4*atan(1.0)
    !pi = 4*atan(1.0)
contains

    double precision function int_cos4(m,n,i,j,l,h) result(y)
    
    implicit none
    
    integer, intent(in) :: m,n,i,j
    real, intent(in) :: l,h
    real :: pi
    
    pi=4.0*atan(1.0)
    
    if (m==0) then
        if (n==0) then
            if (i==0) then
                if (j==0) then
                    y=4*h*l
                else 
                    y=(4*h*l*sin(j*pi))/(j*pi)
                end if
            else
                if (j==0) then
                    y=(4*h*l*sin(i*pi))/(i*pi)
                else
                    y=(4*h*l*sin(i*pi)*sin(j*pi))/(i*j*pi**2)
                end if
            end if
        else
            if (i==0) then
                if (j==0) then
                    y=(4*h*l*sin(n*pi))/(n*pi)
                else
                    if (n==j) then
                        y=2*h*l+(h*l*sin(2*j*pi))/(j*pi)
                    else
                        y=(4*h*j*l*cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)-(4*h*l*n*cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)
                    end if
                end if
            else
                if (j==0) then
                    y=(4*h*l*sin(i*pi)*sin(n*pi))/(i*n*pi**2)
                else
                    if (n==j) then
                        y=(2*h*l*sin(i*pi))/(i*pi)+(h*l*sin(i*pi)*sin(2*j*pi))/(i*j*pi**2)
                    else
                        y=(4*h*j*l*cos(n*pi)*sin(i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi**2)&
                          -(4*h*l*n*cos(j*pi)*sin(i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi**2)
                    end if
                end if
            end if
        end if
    else
        if (n==0) then
            if (i==0) then
                if (j==0) then
                    y=(4*h*l*sin(m*pi))/(m*pi)
                else
                    y=(4*h*l*sin(j*pi)*sin(m*pi))/(j*m*pi**2)
                end if
            else
                if (j==0) then
                    if (m==i) then
                        y=2*h*l+(h*l*sin(2*i*pi))/(i*pi)
                    else
                        y=(2*h*l*sin((i-m)*pi))/((i-m)*pi)+(2*h*l*sin((i+m)*pi))/((i+m)*pi)
                    end if
                else
                    if (m==i) then
                        y=(2*h*l*sin(j*pi))/(j*pi)+(h*l*sin(2*i*pi)*sin(j*pi))/(i*j*pi**2)
                    else
                        y=(2*h*l*sin(j*pi)*sin((i-m)*pi))/(j*(i-m)*pi**2)+(2*h*l*sin(j*pi)*sin((i+m)*pi))/(j*(i+m)*pi**2)
                    end if
                end if
            end if
        else
            if (i==0) then
                if (j==0) then
                    y=(4*h*l*sin(m*pi)*sin(n*pi))/(m*n*pi**2)
                else
                    if (n==j) then
                        y=(2*h*l*sin(m*pi))/(m*pi) + (h*l*sin(2*j*pi)*sin(m*pi))/(j*m*pi**2)
                    else 
                        y=(4*h*j*l*cos(n*pi)*sin(j*pi)*sin(m*pi))/(m*(j**2-n**2)*pi**2)&
                          -(4*h*l*n*cos(j*pi)*sin(m*pi)*sin(n*pi))/(m*(j**2-n**2)*pi**2)
                    end if
                end if
            else
                if (j==0) then
                    if (m==i) then
                        y=(2*h*l*sin(n*pi))/(n*pi)+(h*l*sin(2*i*pi)*sin(n*pi))/(i*n*pi**2)
                    else
                        y=(2*h*l*sin((i-m)*pi)*sin(n*pi))/((i-m)*n*pi**2)+(2*h*l*sin((i+m)*pi)*sin(n*pi))/((i+m)*n*pi**2)
                    end if
                else
                    if (m==i) then
                        if (n==j) then
                            y=h*l+(h*l*sin(2*i*pi))/(2*i*pi)+(h*l*sin(2*j*pi))/(2*j*pi)&
                              +(h*l*sin(2*i*pi)*sin(2*j*pi))/(4*i*j*pi**2)
                        else
                            y=(2*h*j*l*cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)&
                              +(h*j*l*cos(n*pi)*sin(2*i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi)&
                              -(2*h*l*n*cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)&
                              -(h*l*n*cos(j*pi)*sin(2*i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi)
                        end if
                    else
                        if (n==j) then
                            y=(2*h*i*l*cos(m*pi)*sin(i*pi))/((i-m)*(i+m)*pi)&
                              +(h*i*l*cos(m*pi)*sin(i*pi)*sin(2*j*pi))/(j*(i-m)*(i+m)*pi**2)&
                              -(2*h*l*m*cos(i*pi)*sin(m*pi))/((i-m)*(i+m)*pi)&
                              -(h*l*m*cos(i*pi)*sin(2*j*pi)*sin(m*pi))/(j*(i-m)*(i+m)*pi**2)
                        else
                            y=(4*h*i*j*l*cos(m*pi)*cos(n*pi)*sin(i*pi)*sin(j*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)&
                            -(4*h*j*l*m*cos(i*pi)*cos(n*pi)*sin(j*pi)*sin(m*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)&
                            -(4*h*i*l*n*cos(j*pi)*cos(m*pi)*sin(i*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)&
                            +(4*h*l*m*n*cos(i*pi)*cos(j*pi)*sin(m*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)
                        end if
                    end if
                end if
            end if
        end if
    end if
    
    end function int_cos4
    
    !the prevoous function seems to be right. I tried once
    
    double precision function int_sin4(m,n,i,j,l,h) result(y)
    
    implicit none
    
    integer, intent(in) :: m,n,i,j
    real, intent(in) :: l,h
    real :: pi
    
    pi=4.0*atan(1.0)

    if (m==0 .OR. n==0 .OR. i==0 .OR. j==0) then
        y=0;
    else
        if (m==i) then
            if (n==j) then
                y=h*l-(h*l*sin(2*i*pi))/(2*i*pi)-(h*l*sin(2*j*pi))/(2*j*pi)+&
                  (h*l*sin(2*i*pi)*sin(2*j*pi))/(4*i*j*pi**2)
            else
                y=(2*h*l*n*cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)-&
                  (h*l*n*cos(n*pi)*sin(2*i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi**2)-&
                  (2*h*j*l*cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)+&
                  (h*j*l*cos(j*pi)*sin(2*i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi**2)
            end if
        else
            if (n==j) then
                y=(2*h*l*m*cos(m*pi)*sin(i*pi))/((i-m)*(i+m)*pi)-&
                  (h*l*m*cos(m*pi)*sin(i*pi)*sin(2*j*pi))/(j*(i-m)*(i+m)*pi**2)-&
                  (2*h*i*l*cos(i*pi)*sin(m*pi))/((i-m)*(i+m)*pi)+&
                  (h*i*l*cos(i*pi)*sin(2*j*pi)*sin(m*pi))/(j*(i-m)*(i+m)*pi**2)
            else
                y=(4*h*l*m*n*cos(m*pi)*cos(n*pi)*sin(i*pi)*sin(j*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                  (4*h*i*l*n*cos(i*pi)*cos(n*pi)*sin(j*pi)*sin(m*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                  (4*h*j*l*n*cos(j*pi)*cos(m*pi)*sin(i*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)+&
                  (4*h*i*j*l*cos(i*pi)*cos(j*pi)*sin(m*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)
            end if
        end if
    end if
    
    end function int_sin4
    
    !the prevoous function seems to be right. I tried once
    
    double precision function int_sincossincos(m,n,i,j,l,h) result(y)
    
    implicit none
    
    integer, intent(in) :: m,n,i,j
    real, intent(in) :: l,h
    real :: pi
    
    pi=4.0*atan(1.0)

    if (m==0 .OR. i==0) then
        y=0
    else
        if (n==0) then
            if (j==0) then
                if (m==i) then
                    y=2*h*l-(h*l*sin(2*i*pi))/(i*pi)
                else
                    y=(2*h*l*sin((i-m)*pi))/((i-m)*pi)-(2*h*l*sin((i+m)*pi))/((i+m)*pi)
                end if
            else
                if (m==i) then
                    y=(2*h*l*sin(j*pi))/(j*pi)-(h*l*sin(2*i*pi)*sin(j*pi))/(i*j*pi**2)
                else
                    y=(2*h*l*sin(j*pi)*sin((i-m)*pi))/(j*(i-m)*pi**2)-&
                      (2*h*l*sin(j*pi)*sin((i+m)*pi))/(j*(i+m)*pi**2)
                end if
            end if
        else
            if (j==0) then
                if (m==i) then
                    y=(2*h*l*sin(n*pi))/(n*pi)-(h*l*sin(2*i*pi)*sin(n*pi))/(i*n*pi**2)
                else
                    y=(2*h*l*sin((i-m)*pi)*sin(n*pi))/((i-m)*n*pi**2)-&
                      (2*h*l*sin((i+m)*pi)*sin(n*pi))/((i+m)*n*pi**2)
                end if
            else
                if (m == i) then
                    if (n==j) then
                        y=h*l-(h*l*sin(2*i*pi))/(2*i*pi)+(h*l*sin(2*j*pi))/(2*j*pi)-&
                          (h*l*sin(2*i*pi)*sin(2*j*pi))/(4*i*j*pi**2)
                    else
                        y=(2*h*j*l*cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)-&
                          (h*j*l*cos(n*pi)*sin(2*i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi)-&
                          (2*h*l*n*cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)+&
                          (h*l*n*cos(j*pi)*sin(2*i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi)
                    end if
                else
                    if (n==j) then
                        y=(2*h*l*m*cos(m*pi)*sin(i*pi))/((i-m)*(i+m)*pi)+&
                          (h*l*m*cos(m*pi)*sin(i*pi)*sin(2*j*pi))/(j*(i-m)*(i+m)*pi**2)-&
                          (2*h*i*l*cos(i*pi)*sin(m*pi))/((i-m)*(i+m)*pi)-&
                          (h*i*l*cos(i*pi)*sin(2*j*pi)*sin(m*pi))/(j*(i-m)*(i+m)*pi**2)
                    else
                        y=(4*h*j*l*m*cos(m*pi)*cos(n*pi)*sin(i*pi)*sin(j*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                          (4*h*i*j*l*cos(i*pi)*cos(n*pi)*sin(j*pi)*sin(m*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                          (4*h*l*m*n*cos(j*pi)*cos(m*pi)*sin(i*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)+&
                          (4*h*i*l*n*cos(i*pi)*cos(j*pi)*sin(m*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)
                    end if
                end if
            end if
        end if
    end if
    
    end function int_sincossincos
    
    !the prevoous function seems to be correct. I tried it once

    double precision function int_cossincossin(m,n,i,j,l,h) result(y)
    
    implicit none
    
    integer, intent(in) :: m,n,i,j
    real, intent(in) :: l,h
    real :: pi
    
    pi=4.0*atan(1.0)
    
    if (n==0 .OR. j==0) then
        y=0
    else
        if (m==0) then
            if (i==0) then
                if (n==j) then
                    y=2*h*l-(h*l*sin(2*j*pi))/(j*pi)
                else
                    y=4*h*l*n*(cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)-&
		      4*h*j*l*(cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)
                end if
            else
                if (n==j) then
                    y=(2*h*i*l*cos(m*pi)*sin(i*pi))/((i-m)*(i+m)*pi)-&
                          (h*i*l*cos(m*pi)*sin(i*pi)*sin(2*j*pi))/(j*(i-m)*(i+m)*pi**2)-&
                          (2*h*l*m*cos(i*pi)*sin(m*pi))/((i-m)*(i+m)*pi)+&
                          (h*l*m*cos(i*pi)*sin(2*j*pi)*sin(m*pi))/(j*(i-m)*(i+m)*pi**2)
                else
                    y=4*h*l*n*(cos(n*pi)*sin(i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi**2)-&
		      4*h*j*l*(cos(j*pi)*sin(i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi**2)
                end if
            end if
        else
            if (i==0) then
                if (n==j) then
                    y=(2*h*l*sin(m*pi))/(m*pi)-(h*l*sin(2*j*pi)*sin(m*pi))/(j*m*pi**2)
                else
                    y=4*h*l*n*(cos(n*pi)*sin(j*pi)*sin(m*pi))/(m*(j**2-n**2)*pi**2)-&
		      4*h*j*l*(cos(j*pi)*sin(m*pi)*sin(n*pi))/(m*(j**2-n**2)*pi**2)
                end if
            else
                if (n == j) then
                    if (m==i) then
                        y=h*l+(h*l*sin(2*i*pi))/(2*i*pi)-(h*l*sin(2*j*pi))/(2*j*pi)-&
                          (h*l*sin(2*i*pi)*sin(2*j*pi))/(4*i*j*pi**2)
                    else
                        y=(2*h*i*l*cos(m*pi)*sin(i*pi))/((i-m)*(i+m)*pi)-&
                          (h*i*l*cos(m*pi)*sin(i*pi)*sin(2*j*pi))/(j*(i-m)*(i+m)*pi**2)-&
                          (2*h*l*m*cos(i*pi)*sin(m*pi))/((i-m)*(i+m)*pi)+&
                          (h*l*m*cos(i*pi)*sin(2*j*pi)*sin(m*pi))/(j*(i-m)*(i+m)*pi**2)
                    end if
                else
                    if (m==i) then
                        y=(2*h*l*n*cos(n*pi)*sin(j*pi))/((j**2-n**2)*pi)+&
                          (h*l*n*cos(n*pi)*sin(2*i*pi)*sin(j*pi))/(i*(j**2-n**2)*pi**2)-&
                          (2*h*j*l*cos(j*pi)*sin(n*pi))/((j**2-n**2)*pi)-&
                          (h*j*l*cos(j*pi)*sin(2*i*pi)*sin(n*pi))/(i*(j**2-n**2)*pi**2)
                    else
                        y=(4*h*i*l*n*cos(m*pi)*cos(n*pi)*sin(i*pi)*sin(j*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                          (4*h*l*m*n*cos(i*pi)*cos(n*pi)*sin(j*pi)*sin(m*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)-&
                          (4*h*i*j*l*cos(j*pi)*cos(m*pi)*sin(i*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)+&
                          (4*h*j*l*m*cos(i*pi)*cos(j*pi)*sin(m*pi)*sin(n*pi))/((i-m)*(i+m)*(j**2-n**2)*pi**2)
                    end if
                end if
            end if
        end if
    end if

    end function int_cossincossin
    
    !The previous function seems to work correctly. I tried it once
    
end module funcs_SDFFS
